//O[o萔
//------------------------
//ϊs
//------------------------
float4x4 mW; //[hs(L̍s)
float4x4 mV; //r[s(J)
float4x4 mP; //ˉe(2D)ϊs

//------------------------
//}eA֌W
//------------------------
float4 MateDiffuse = float4(1, 1, 1, 1);//}eAF

//eNX`(摜{)
texture MateDiffuseTex;	//}eÃeNX`
//MateDiffuseTexpTv(F擾ł)
sampler MateDiffuseSmp = sampler_state {
	Texture = <MateDiffuseTex>;	//gpeNX`
	MipFilter = LINEAR;	//tB^
	MinFilter = LINEAR;	//tB^
	MagFilter = LINEAR;	//tB^
	AddressU = Wrap;	//eNX`AhVO[h
	AddressV = Wrap;	//eNX`AhVO[h
};


//------------------------
//Cg֌W
//------------------------
float4 LightColor = float4(1, 1, 1, 1);
float3 LightDir = float3(0, -1, 0);//s̕
float4 LightAmbient; //(΂ɓ)

//------------------------
// V[摜
//------------------------
//eNX`(摜{)
texture SceneTex;	//}eÃeNX`
//MateDiffuseTexpTv(F擾ł)
sampler SceneSmp = sampler_state {
	Texture = <SceneTex>;	//gpeNX`
	MipFilter = LINEAR;	//tB^
	MinFilter = LINEAR;	//tB^
	MagFilter = LINEAR;	//tB^
	AddressU = Wrap;	//eNX`AhVO[h
	AddressV = Wrap;	//eNX`AhVO[h
};

//------------------------
// VhE}bvp 
//------------------------
float4x4 mLightVP;
// Cg̃r[s񁖎ˉes 
texture ShadowTex; // VhE}bv([x}bv) 
sampler ShadowSmp=sampler_state {
	Texture=<ShadowTex>; 
	MipFilter=NONE; 
	MinFilter=POINT;
	MagFilter=POINT;
	AddressU = Clamp; 
	AddressV = Clamp;
}; 
float Margin = 0.002; // }bnoh(ȁX͗l)h~p

//_VF[_o͗p\
//_VF[_̏oחpi{[
struct VS_OUT {
	float4 Pos:POSITION;//ˉe(2D)W
	float3 wN:TEXCOORD0;//POSITIONȍ~TEXCOORDł悢
	float2 MeshUV:TEXCOORD1;

	float4 wvpPos : TEXCOORD2;
	float3 wPos : TEXCOORD3;
};

//_VF[_
VS_OUT VS(float4 pos:POSITION,
		  float3 normal : NORMAL,//@xNg
		  float2 mesh_uv : TEXCOORD0)//UVW
{
	VS_OUT Out;//o͗pi{[
	////ˉe(2D)W
	Out.Pos = mul(pos, mW);		//L̍sœ
		Out.wPos = Out.Pos.xyz;
	Out.Pos = mul(Out.Pos, mV);	//J̓
	Out.Pos = mul(Out.Pos, mP);	//ˉe(2D)ϊ

	Out.wvpPos = Out.Pos;
	
	Out.wN = mul(normal, (float3x3)mW);
	Out.wN = normalize(Out.wN); //׃NgK...xNg̒Pɂ
	
	Out.MeshUV = mesh_uv;

	return Out;					//mul(a,b)...abŕϊ
}

//sNZVF[_o͗p\
struct PS_OUT {
	float4 Color:COLOR0;
};

//sNZVF[_
PS_OUT PS(VS_OUT In){

	//@𐳋K
	float3 w_normal = normalize(In.wN);
	
	//------------------------
	//fF
	//------------------------
	float4 texCol = tex2D(MateDiffuseSmp, In.MeshUV);//tex2D(smp,uv)smpeNX`uv̈ʒu̐F擾
	float4 modelCol = MateDiffuse * texCol;

	//------------------------
	//CgF
	//------------------------
	float4 lightCol = float4(0, 0, 0, 1);
	//sCeBO(o[h)
	float LPow = dot(-LightDir, w_normal);	//dot(a,b)...ab̓
	LPow = saturate(LPow);					//saturate(a)...a0~1Ɏ߂

	//================================================
	// VhE}bv
	//================================================
	// Cg 2D W
	float4 LiPos = mul(float4(In.wPos, 1), mLightVP);
	LiPos.xyz = LiPos.xyz / LiPos.w;
	// VhE}bv(xy -1`1 ȓ z  0`1)
	if( abs(LiPos.x) <= 1 && abs(LiPos.y) <= 1 && LiPos.z <= 1){
		// 2D Wn UV Wnɕϊ
		float2 uv = LiPos.xy * 0.5 + 0.5;
		uv.y = 1 - uv.y;
		float z = LiPos.z - Margin;
		// eɂȂĂ邩ǂ
		float S_Pow = tex2D(ShadowSmp, uv).r < z ? 0 : 1;
		LPow = min(LPow, S_Pow); // Âgp
	} 

	lightCol.rgb += LightColor.rgb * (LPow / 2.0f);	//̐F * 邳
	//
	lightCol.rgb += LightAmbient.rgb / 0.5f;

	//------------------------
	//Fo
	//------------------------
	float4 diffuseCol = modelCol * lightCol;//gUF@fF * CgF
	PS_OUT Out;
	Out.Color = diffuseCol;
	return Out;

}

//eNjbN
technique Tech {
	pass P0 {
		VertexShader = compile vs_3_0 VS();//_VF[_,VS()g
		PixelShader = compile ps_3_0 PS();//sNZVF[_,PS()g
	}							//vs_3_0, ps_3_0, gp.VF[_f
}

//------------------------------------------------------------------------------------------------

PS_OUT ReversePS(VS_OUT In)
{
	// 2DʓUV߂(Proj -> UV)
	In.wvpPos.xyz /= In.wvpPos.w;
	float2 uv = In.wvpPos.xy * 0.5 + 0.5;
	uv.y = 1 - uv.y;

	uv.x += (1.0 / 1280)*0.5;
	uv.y += (1.0 / 720)*0.5;

	// SceneTexAUV̈ʒu̐F(color)擾
	float4 color = tex2D(SceneSmp, uv);

	// ̐F𔽓](1-color.rgb)
	color.rgb = 1 - color.rgb;

	// ̐Fo
	PS_OUT Out;
	Out.Color = color;
	return Out;

}

//eNjbN
technique ReverseTech {
	pass P0 {
		VertexShader = compile vs_3_0 VS();//_VF[_,VS()g
		PixelShader = compile ps_3_0 ReversePS();//sNZVF[_,PS()g
	}							//vs_3_0, ps_3_0, gp.VF[_f
}

//------------------------------------------------------------------------------------------------

//------------------------
//Change
//------------------------
float Glow;
float Life;

//C`S
PS_OUT ChangePS1(VS_OUT In)
{

	//@𐳋K
	float3 w_normal = normalize(In.wN);

	//------------------------
	//fF
	//------------------------
	float4 texCol = tex2D(MateDiffuseSmp, In.MeshUV);//tex2D(smp,uv)smpeNX`uv̈ʒu̐F擾
	float4 modelCol = MateDiffuse * texCol;

	//------------------------
	//CgF
	//------------------------
	float4 lightCol = float4(0, 0, 0, 1);
	//sCeBO(o[h)
	float LPow = dot(-LightDir, w_normal);	//dot(a,b)...ab̓
	LPow = saturate(LPow);					//saturate(a)...a0~1Ɏ߂
	lightCol.rgb += LightColor.rgb * LPow;	//̐F * 邳
											//
	lightCol.rgb += LightAmbient.rgb;

	//------------------------
	//Fo
	//------------------------
	
	float glow;
	float life;
	glow = Glow;
	life = Life;

	life = saturate(life / 10);
	glow = saturate(glow / 200);
	modelCol.r = (0.8f) + (life - 1);
	modelCol.b = ((glow - 0.8f) * -1) + (life - 1);
	modelCol.g = ((glow - 1) * -1) + (life - 1);

	float4 diffuseCol = modelCol * lightCol;//gUF@fF * CgF


	PS_OUT Out;
	Out.Color = diffuseCol;
	return Out;

}

//g}g
PS_OUT ChangePS2(VS_OUT In)
{

	//@𐳋K
	float3 w_normal = normalize(In.wN);

	//------------------------
	//fF
	//------------------------
	float4 texCol = tex2D(MateDiffuseSmp, In.MeshUV);//tex2D(smp,uv)smpeNX`uv̈ʒu̐F擾
	float4 modelCol = MateDiffuse * texCol;

	//------------------------
	//CgF
	//------------------------
	float4 lightCol = float4(0, 0, 0, 1);
	//sCeBO(o[h)
	float LPow = dot(-LightDir, w_normal);	//dot(a,b)...ab̓
	LPow = saturate(LPow);					//saturate(a)...a0~1Ɏ߂
	lightCol.rgb += LightColor.rgb * LPow;	//̐F * 邳
											//
	lightCol.rgb += LightAmbient.rgb;

	//------------------------
	//Fo
	//------------------------

	float glow;
	float life;
	glow = Glow;
	life = Life;

	life = saturate(life / 15);
	glow = saturate(glow / 300);
	modelCol.r = (glow + 0.5f) + (life - 1);
	modelCol.b = (glow * -1) + (life - 1);
	modelCol.g = ((glow - 1) * -1) + (life - 1);

	float4 diffuseCol = modelCol * lightCol;//gUF@fF * CgF


	PS_OUT Out;
	Out.Color = diffuseCol;
	return Out;

}

//C`S
//eNjbN
technique ChangeStrawberryTech {
	pass P0 {
		VertexShader = compile vs_3_0 VS();//_VF[_,VS()g

		PixelShader = compile ps_3_0 ChangePS1();//sNZVF[_,PS()g
	}							//vs_3_0, ps_3_0, gp.VF[_f
}

//g}g
//eNjbN
technique ChangeTomatoTech {
	pass P0 {
		VertexShader = compile vs_3_0 VS();//_VF[_,VS()g

		PixelShader = compile ps_3_0 ChangePS2();//sNZVF[_,PS()g
	}							//vs_3_0, ps_3_0, gp.VF[_f
}

//------------------------------------------------------------------------------------------------

//------------------------
//Alpha
//------------------------
float Alpha;

PS_OUT AlphaPS(VS_OUT In)
{

	//@𐳋K
	float3 w_normal = normalize(In.wN);

	//------------------------
	//fF
	//------------------------
	float4 texCol = tex2D(MateDiffuseSmp, In.MeshUV);//tex2D(smp,uv)smpeNX`uv̈ʒu̐F擾
	float4 modelCol = MateDiffuse * texCol;

	//------------------------
	//CgF
	//------------------------
	float4 lightCol = float4(0, 0, 0, 1);
	//sCeBO(o[h)
	float LPow = dot(-LightDir, w_normal);	//dot(a,b)...ab̓
	LPow = saturate(LPow);					//saturate(a)...a0~1Ɏ߂
	lightCol.rgb += LightColor.rgb * LPow;	//̐F * 邳
											//
	lightCol.rgb += LightAmbient.rgb;

	//------------------------
	//Fo
	//------------------------

	modelCol.a = Alpha;

	float4 diffuseCol = modelCol * lightCol;//gUF@fF * CgF

	PS_OUT Out;
	Out.Color = diffuseCol;
	return Out;

}


//eNjbN
technique AlphaTech {
	pass P0 {
		VertexShader = compile vs_3_0 VS();//_VF[_,VS()g

		PixelShader = compile ps_3_0 AlphaPS();//sNZVF[_,PS()g
	}							//vs_3_0, ps_3_0, gp.VF[_f
}

//------------------------------------------------------------------------------------------------

//------------------------
//Shadow
//------------------------
PS_OUT ShadowPS(VS_OUT In)
{

	//@𐳋K
	float3 w_normal = normalize(In.wN);

	//------------------------
	//fF
	//------------------------
	float4 texCol = tex2D(MateDiffuseSmp, In.MeshUV);//tex2D(smp,uv)smpeNX`uv̈ʒu̐F擾
	float4 modelCol = MateDiffuse * texCol;

	//------------------------
	//CgF
	//------------------------
	float4 lightCol = float4(0, 0, 0, 1);
	//sCeBO(o[h)
	float LPow = dot(-LightDir, w_normal);	//dot(a,b)...ab̓
	LPow = saturate(LPow);					//saturate(a)...a0~1Ɏ߂
	lightCol.rgb += LightColor.rgb * LPow;	//̐F * 邳
											//
	lightCol.rgb += LightAmbient.rgb;

	//------------------------
	//Fo
	//------------------------

	modelCol.rgb = 0.0f;

	float4 diffuseCol = modelCol * lightCol;//gUF@fF * CgF

	PS_OUT Out;
	Out.Color = diffuseCol;
	return Out;

}


//eNjbN
technique ShadowTech {
	pass P0 {
		VertexShader = compile vs_3_0 VS();//_VF[_,VS()g

		PixelShader = compile ps_3_0 ShadowPS();//sNZVF[_,PS()g
	}							//vs_3_0, ps_3_0, gp.VF[_f
}

//------------------------------------------------------------------------------------------------

//------------------------
//֊sVF[_
//------------------------

//֊spf[^
float4 OutlineColor;//֊sF
float  OutlineSize; //

					//_poחpf[^
struct OutlineVS_OUT {
	float4 Pos:POSITION;
};

//VS
//Outline([JW,[J@)
OutlineVS_OUT OutlineVS(float4 pos:POSITION,
	float3 normal : NORMAL) {
	OutlineVS_OUT Out;
	//Posnormalɂ炷
	pos.xyz += normal * OutlineSize;
	//2DW
	Out.Pos = mul(pos, mW);		//L̍sœ
	Out.Pos = mul(Out.Pos, mV);	//J̓
	Out.Pos = mul(Out.Pos, mP);	//ˉe(2D)ϊ
	return Out;
}

//PS
//sNZVF[_o͗p\
float4 OutlinePS(OutlineVS_OUT In) :COLOR0
{
	return OutlineColor;
}

//eNjbN
technique OutlineTech {
	pass P0 {
		VertexShader = compile vs_3_0 OutlineVS();
		PixelShader = compile ps_3_0 OutlinePS();
		CullMode = CW;	//	JO[hCW(ʕ`)
	}
}

