//------------------------
//VhE}bv
//------------------------

float4x4 mW; //r[s(J)
float4x4 mLV; //ˉe(2D)ϊs
float4x4 mLP;

texture MeshTex;
sampler MeshSmp = sampler_state {
	Texture = <MeshTex>;	//gpeNX`
	MipFilter = LINEAR;	//tB^
	MinFilter = LINEAR;	//tB^
	MagFilter = LINEAR;	//tB^
	AddressU = Wrap;	//eNX`AhVO[h
	AddressV = Wrap;	//eNX`AhVO[h
};

struct VS_OUT
{
	float4 Pos		: POSITION;
	float2 MeshUV	: TEXCOORD0;
	float2 Depth	: TEXCOORD1;
};

//_VF[_
VS_OUT VS(
	float4 pos		: POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0
) {
	VS_OUT Out;

	//_WCgɑ΂Ďˉeϊ
	Out.Pos = mul(pos, mW);			//L̍sœ
	Out.Pos = mul(Out.Pos, mLV);	//J̓
	Out.Pos = mul(Out.Pos, mLP);	//ˉe(2D)ϊ

									//Ổ̕êh~
	Out.Pos.z = max(0, Out.Pos.z);
	//UV
	Out.MeshUV = mesh_uv;
	//[x
	Out.Depth.xy = Out.Pos.zw;

	return Out;

}

//sNZVF[_
float4 PS(VS_OUT In) : COLOR{
	//At@eXg 0.01ȉ̃l̃sNZ͏O
//	clip(tex2D(MeshSmp,In.MeshUV).a - 0.01);

	return In.Depth.x / In.Depth.y;

}

//eNjbN
technique Tech {
	pass P0 {
		AlphaBlendEnable = false;

		VertexShader = compile vs_3_0 VS();//_VF[_,VS()g
		PixelShader = compile ps_3_0 PS();//sNZVF[_,PS()g
	}							//vs_3_0, ps_3_0, gp.VF[_f
}